<template>
    <div>
        <TitlePage title="Les Actus !"/>
        <section class="list-news">
            <div class="select" v-if="categories.length >= 1">
                <select class="form-control" v-if="selected != undefined && selected != null" v-model="selected" v-on:change="getNews()">
                    <option value="null">Catégorie</option>
                    <option v-for="category in categories" :value="category.name" v-bind:key="category.id">{{ category.name }}</option>
                </select>
            </div>
            <div v-if="news.length == 0 && loading == false" class="info-chargement">
                <h3> Aucun résultats ! 🤔</h3>
            </div>
            <ul v-if="news.length > 0" class="card_center d-flex flex-row flex-wrap justify-content-center">
                <li class="col-12 col-md-4 col-lg-3 list-project-album" v-for="actu in news" v-bind:key="actu.title">
                    <div class="card card_projet">
                        <div class="card-body">
                            <h5 class="card-title"> {{ actu.title }} </h5>
                            <p class="card-text"> {{ actu.description }}</p>
                            <span class="card-date"> Publié le {{ actu.date | moment("dddd Do MMMM YYYY, à HH:mm:ss") }}</span>
                            <a :href="actu.url" target="_blank"  class="btn btn-primary card_btn"> En savoir plus !</a>
                        </div>
                    </div>
                </li>
            </ul>
            <div v-if="loading" class="info-chargement">
                <h3> Chargements des actualités ... 🧐</h3>
            </div>
            <div v-if="!loading && page < nbPages" class="info-chargement">
                <button class="btn btn-primary m10" v-on:click="loadMore()">Afficher plus !</button>
            </div>
        </section>
    </div>
</template>

<style scoped>
    .card-title  {
        font-size: 16px;
    }
    .card-text {
        font-size: 13px;
    }
    .card-date {
        font-size: 10px;
        text-align: left!important;
    }
    .card {
        max-width: 80%;
    }
    .select {
       margin: 10px;
    }
    .info-chargement {
        text-align: center;
    }
    .info-chargement > h3 {
        font-size: 22px!important;
        margin: 10px!important;
    }
</style>

<script>
    export default {
        data(){
            return{
                news:[],
                loading: true,
                selected: "null",
                urlNews: "/news/get",
                page: 1,
                nbPages: 0,
                totalcount: 0,
                categories: [],
            }
        },
        created: async function(){
            await this.getCategories();
            await this.getNews();
        },
        methods:{
            getCategories: async function(){
                var vue = this;
                await vue.$axios({
                    method: "GET",
                    url:"/news/categories",
                    dataType:'JSON',}).then(response => {
                        vue.categories = response.data;
                })
            },
            getNews: async function(){
                var vue = this;
                this.page = 1;
                this.news = [];
                this.loading = true;
                this.urlNews = "/news/get?page=" + this.page
                if (this.selected != undefined || this.selected != null || this.selected != "") 
                {
                    this.urlNews += "&category="+this.selected
                }
                await vue.$axios({
                    method: "GET",
                    url: this.urlNews,
                    dataType:'JSON',}).then(response => {
                        vue.news = response.data.data;
                        vue.totalcount = Number(response.data.totalCount);
                        var test = Number(response.data.totalCount) / response.data.data.length;
                        vue.nbPages = Number(response.data.totalCount) % response.data.data.length == 0 ? Math.trunc(test) : Math.trunc(test) + 1;
                        this.loading = false;
                })
            },
            loadMore: async function(){
                var vue = this;
                this.page++;
                this.loading = true;
                this.urlNews = "/news/get?page="+ this.page
                if (this.selected != undefined || this.selected != null || this.selected != "") 
                {
                    this.urlNews += "&category="+this.selected
                }
                await vue.$axios({
                    method: "GET",
                    url: this.urlNews,
                    dataType:'JSON',}).then(response => {
                        vue.news.push(...response.data.data);
                        this.loading = false;
                })
            },
        },
        computed:{
        }
    }
</script>
